/*
   Counts 213 occurrences in O(n^2).

   The solution considers each point of the permutation as a potential "2".
   Then a linear sweep through the remaining part of the permutation from left
   to right is used to count the number of ascents that cross this "2", making
   the "1" and "3".
*/

#include <bits/stdc++.h>
using namespace std;
#define rep(i,a,b) for (auto i=(a); i<(b); ++i)
#define iter(it,c) for (auto it = (c).begin(); it != (c).end(); ++it)
typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;
typedef vector<vi> vvi;
typedef long long ll;
const int INF = 2147483647;

int main() {
    cin.sync_with_stdio(false);

    int ts;
    cin >> ts;

    vi found;
    rep(t,0,ts) {
        int n;
        cin >> n;

        vi arr(n);
        rep(i,0,n) {
            cin >> arr[i];
        }

        ll cnt = 0;
        rep(i,0,n) {

            int below = 0;
            rep(j,i+1,n) {
                if (arr[j] < arr[i]) {
                    below++;
                }
                if (arr[j] > arr[i]) {
                    cnt += below;
                }
            }
        }

        if (cnt != 0) {
            found.push_back(t);
        }
    }

    cout << found.size() << endl;
    iter(it,found) {
        cout << *it+1 << endl;
    }

    return 0;
}

