#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

void get_height( const vector<int> &parent, const vector<bool> &used, vector<int> &height, int node) {
	if( node == 0 or used[node] ) {
		height[node] = 0;
		return;
	}
	if( height[parent[node]] < 0) 
		get_height(parent, used, height, parent[node]);
	height[node] = height[parent[node]]+1;
}

void remove_parents( const vector<int> &parent, vector<bool> &used, int node ) {
	if( !used[node] ) {
		used[node] = true;
		if( node != 0 )
			remove_parents( parent, used, parent[node] ); 
	}
}

int main() {
	int n,k;
	cin >> n >> k;

	vector<ll> a(k);
	for( int i= 0; i < k; i++ )
		cin >> a[i];
	sort( a.rbegin(), a.rend() );


	vector<int> parent(n);
	vector<bool> used(n, false);
	vector<bool> is_leaf(n, true);

	for( int i = 1; i < n; i++ ) {
		int tmp;
		cin >> tmp;
		parent[i] = tmp;
		is_leaf[tmp] = false;
	}
	vector<int> leafs;
	for( int i = 0; i < n; i++ ) {
		if( is_leaf[i] ) 
			leafs.push_back(i);
	}

	vector<int> height(n);
	ll sm = 0;
	for( int i = 0; i < k; i++ ) {
		fill( height.begin(), height.end(), -1);

		int bestheight = -1;
		int bestleaf = -1;
		for( int j = 0; j < k; j++ ) {
			int leaf = leafs[j];
			get_height( parent, used, height, leaf );
			if( height[leaf] > bestheight ) {
				bestheight = height[leaf];
				bestleaf = leaf;
			}
		}

		sm += bestheight * a[i];
		remove_parents( parent, used, bestleaf );
	}

	cout << sm << endl;
	return 0;
}
